(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15707,        411]
NotebookOptionsPosition[     14847,        391]
NotebookOutlinePosition[     15272,        408]
CellTagsIndexPosition[     15229,        405]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
   "pathName", "=", "\"\</Example/Path/To/Folder/With/Graph/Files/\>\""}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "Input", " ", "the", " ", "path", " ", "to", " ", "the", " ", "folder", 
     " ", "containing", " ", "the", " ", "files", " ", "with", " ", "the", 
     " ", "lists", " ", "of", " ", "graphs"}], ",", " ", 
    RowBox[{"including", " ", "a", " ", "trailing", " ", "slash"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fileName11", "=", 
   RowBox[{"StringJoin", "[", 
    RowBox[{"pathName", ",", "\"\<elevenVertices.g6\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fileName12", "=", 
   RowBox[{"StringJoin", "[", 
    RowBox[{"pathName", ",", "\"\<twelveVertices.g6\>\""}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.843137304557564*^9, 3.8431373240381737`*^9}, {
  3.843137758103066*^9, 3.84313776302626*^9}, {3.843214890514823*^9, 
  3.843214906844496*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"763b639d-c652-4231-b73d-9c8e50f5a1ec"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Set", " ", "the", " ", "random", " ", "seed"}], ",", " ", 
    RowBox[{
    "then", " ", "define", " ", "methods", " ", "we", " ", "will", " ", "use",
      " ", "later"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"SeedRandom", "[", "1234", "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vars", "[", 
     RowBox[{"d_", ",", "n_"}], "]"}], ":=", 
    RowBox[{"Flatten", "[", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{"Function", "[", 
        RowBox[{"i", ",", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{"Function", "[", 
            RowBox[{"k", ",", 
             RowBox[{"Subscript", "[", 
              RowBox[{
               RowBox[{"Subscript", "[", 
                RowBox[{"x", ",", "i"}], "]"}], ",", "k"}], "]"}]}], "]"}], 
           ",", 
           RowBox[{"Range", "[", "d", "]"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"Range", "[", "n", "]"}]}], "]"}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"pairwiseDistances", "[", 
     RowBox[{"d_", ",", "G_"}], "]"}], ":=", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{"Function", "[", 
       RowBox[{"e", ",", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"i", ",", "j"}], "}"}], ",", 
          RowBox[{
           RowBox[{"i", "=", 
            RowBox[{"e", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ";", 
           RowBox[{"j", "=", 
            RowBox[{"e", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ";", 
           RowBox[{"Total", "[", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{"Function", "[", 
               RowBox[{"k", ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Subscript", "[", 
                    RowBox[{
                    RowBox[{"Subscript", "[", 
                    RowBox[{"x", ",", "i"}], "]"}], ",", "k"}], "]"}], "-", 
                   RowBox[{"Subscript", "[", 
                    RowBox[{
                    RowBox[{"Subscript", "[", 
                    RowBox[{"x", ",", "j"}], "]"}], ",", "k"}], "]"}]}], 
                  ")"}], "^", "2"}]}], "]"}], ",", 
              RowBox[{"Range", "[", "d", "]"}]}], "]"}], "]"}]}]}], "]"}]}], 
       "]"}], ",", "G"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"jacobian", "[", 
     RowBox[{"d_", ",", "n_", ",", "G_"}], "]"}], ":=", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{"Function", "[", 
       RowBox[{"y", ",", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"dist", ",", 
            RowBox[{"D", "[", 
             RowBox[{"dist", ",", "y"}], "]"}]}], "]"}], ",", 
          RowBox[{"pairwiseDistances", "[", 
           RowBox[{"d", ",", "G"}], "]"}]}], "]"}]}], "]"}], ",", 
      RowBox[{"vars", "[", 
       RowBox[{"d", ",", "n"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"numericalJacobian", "[", 
     RowBox[{"d_", ",", "n_", ",", "G_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"jacob", ",", "subRules"}], "}"}], ",", "\[IndentingNewLine]", 
      
      RowBox[{
       RowBox[{"jacob", "=", 
        RowBox[{"jacobian", "[", 
         RowBox[{"d", ",", "n", ",", "G"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"subRules", "=", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"y", ",", 
            RowBox[{"y", "\[Rule]", 
             RowBox[{"RandomReal", "[", "]"}]}]}], "]"}], ",", 
          RowBox[{"vars", "[", 
           RowBox[{"d", ",", "n"}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"jacob", "/.", "subRules"}]}]}], "\[IndentingNewLine]", 
     "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"edgeToIndex", "[", 
     RowBox[{"e_", ",", "n_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"FirstPosition", "[", 
      RowBox[{
       RowBox[{"K", "[", "n", "]"}], ",", "e"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"graphToIndex", "[", 
     RowBox[{"G_", ",", "n_"}], "]"}], ":=", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"edgeToIndex", "[", 
        RowBox[{"#", ",", "n"}], "]"}], "&"}], ",", "G"}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"edgeToIndex", "[", "e_", "]"}], ":=", 
    RowBox[{
     RowBox[{"FirstPosition", "[", 
      RowBox[{"K12", ",", "e"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"graphToIndex", "[", "G_", "]"}], ":=", 
    RowBox[{"Map", "[", 
     RowBox[{"edgeToIndex", ",", "G"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"actualGraphToIndex", "[", "G_", "]"}], ":=", 
    RowBox[{"graphToIndex", "[", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"#", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{"#", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "&"}], ",", 
       RowBox[{"EdgeList", "[", "G", "]"}]}], "]"}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"K12", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"i", ",", "j"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", "11"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", 
           RowBox[{"i", "+", "1"}], ",", "12"}], "}"}]}], "]"}], ",", "1"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"jacob", "=", 
     RowBox[{"numericalJacobian", "[", 
      RowBox[{"3", ",", "12", ",", "K12"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"isIndependent", "[", "G_", "]"}], ":=", 
    RowBox[{
     RowBox[{"MatrixRank", "[", 
      RowBox[{"jacob", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "G"}], "]"}], "]"}], "]"}], "==", 
     "25"}]}]}]}]], "Input",
 CellChangeTimes->{{3.8326946576183147`*^9, 3.832694709982582*^9}, {
  3.8424405755396767`*^9, 3.842440575671933*^9}, {3.84245969980192*^9, 
  3.8424597106573143`*^9}, {3.842459782325161*^9, 3.842459787300139*^9}, {
  3.842460965583562*^9, 3.84246096576182*^9}, {3.84313778282714*^9, 
  3.84313781838692*^9}},ExpressionUUID->"ec7ce279-899c-43ae-a553-\
ece32a419494"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Import", " ", "and", " ", "count", " ", "the", " ", "list", " ", "of", 
    " ", "graphs", " ", "to", " ", "check"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"elevenVertices", "=", 
     RowBox[{"Import", "[", "fileName11", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"twelveVertices", "=", 
     RowBox[{"Import", "[", "fileName12", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"potentialCircuits", "=", 
     RowBox[{"Join", "[", 
      RowBox[{"elevenVertices", ",", "twelveVertices"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Length", "[", "potentialCircuits", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.8262030124294643`*^9, 3.826203024927949*^9}, {
  3.826203061095336*^9, 3.826203074189816*^9}, {3.82620337173874*^9, 
  3.826203376515937*^9}, {3.826203444064184*^9, 3.8262034472177677`*^9}, {
  3.8323204578173513`*^9, 3.832320478066917*^9}, {3.8326793326590567`*^9, 
  3.8326793338850594`*^9}, {3.832679448891725*^9, 3.832679449098187*^9}, {
  3.832679897057259*^9, 3.832679898067937*^9}, {3.8424442050077887`*^9, 
  3.842444220899914*^9}, {3.842444285944146*^9, 3.842444286114511*^9}, {
  3.842459654121554*^9, 3.8424596544183817`*^9}, {3.842459698042747*^9, 
  3.842459726190976*^9}, {3.843137329845874*^9, 3.843137346707692*^9}, {
  3.843137814273652*^9, 
  3.8431378477802067`*^9}},ExpressionUUID->"9201a35d-75ff-400e-8b47-\
672670292b03"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "Extract", " ", "the", " ", "list", " ", "of", " ", "graphs", " ", 
     "where", " ", "we", " ", 
     RowBox[{"don", "'"}], "t", " ", "immediately", " ", "find", " ", "a", 
     " ", "configuration", " ", "that", " ", "has", " ", "a", " ", "full"}], 
    "-", 
    RowBox[{"rank", " ", "rigidity", " ", "matrix"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"dependentSets", "=", 
     RowBox[{"Select", "[", 
      RowBox[{"potentialCircuits", ",", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"isIndependent", "[", 
          RowBox[{"actualGraphToIndex", "[", "#", "]"}], "]"}], "]"}], 
        "&"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Length", "[", "dependentSets", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.842441211564824*^9, 3.842441218258305*^9}, {
  3.842441411405148*^9, 3.8424414997936296`*^9}, {3.8424419469661407`*^9, 
  3.8424421044625273`*^9}, {3.84244214076574*^9, 3.842442560770602*^9}, {
  3.842442591623159*^9, 3.842442599806188*^9}, {3.842442633453068*^9, 
  3.842442668771969*^9}, {3.842442703487135*^9, 3.84244280649837*^9}, {
  3.8424443763449593`*^9, 3.842444442971868*^9}, {3.842444654914939*^9, 
  3.8424446624256067`*^9}, {3.8424596220678663`*^9, 3.8424596305253973`*^9}, {
  3.843137792981184*^9, 3.843137793967834*^9}, {3.843137861165619*^9, 
  3.8431378976371613`*^9}},ExpressionUUID->"ce6ce60d-5455-4de1-871b-\
b60ca3697b0d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Eliminate", " ", "all", " ", "graphs", " ", "that", " ", "have", " ", "a",
     " ", "K5", " ", "subgraph", " ", "and", " ", "are", " ", "thus", " ", 
    "not", " ", 
    RowBox[{"circuits", ".", " ", "Count"}], " ", 
    RowBox[{"what", "'"}], "s", " ", "left"}], "*)"}], "\[IndentingNewLine]", 
  
  RowBox[{
   RowBox[{
    RowBox[{"K5", "=", 
     RowBox[{"CompleteGraph", "[", "5", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"noK5", "=", 
     RowBox[{"Select", "[", 
      RowBox[{"dependentSets", ",", 
       RowBox[{"Function", "[", 
        RowBox[{"G", ",", 
         RowBox[{"Not", "[", 
          RowBox[{"AnyTrue", "[", 
           RowBox[{
            RowBox[{"Subsets", "[", 
             RowBox[{
              RowBox[{"VertexList", "[", "G", "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"5", ",", "5"}], "}"}]}], "]"}], ",", 
            RowBox[{"Function", "[", 
             RowBox[{"S", ",", 
              RowBox[{"IsomorphicGraphQ", "[", 
               RowBox[{
                RowBox[{"Subgraph", "[", 
                 RowBox[{"G", ",", "S"}], "]"}], ",", "K5"}], "]"}]}], 
             "]"}]}], "]"}], "]"}]}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Length", "[", "noK5", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.842458684195766*^9, 3.842458806700008*^9}, {
  3.842458838486878*^9, 3.842458855152207*^9}, {3.842458893401442*^9, 
  3.8424589074868383`*^9}, {3.842459587796754*^9, 3.842459593417123*^9}, {
  3.842459631536186*^9, 3.842459633427909*^9}, {3.843137899429443*^9, 
  3.843137965926558*^9}},ExpressionUUID->"75e9e0c3-e080-47a7-9851-\
42dc42bb794f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Eliminate", " ", "all", " ", "graphs", " ", "that", " ", "have", " ", "a",
     " ", "subgraph", " ", "on", " ", "6", " ", "vertices", " ", "with", " ", 
    "13", " ", "edges", " ", "and", " ", "are", " ", "thus", " ", "not", " ", 
    
    RowBox[{"circuits", ".", " ", "Note"}], " ", "that", " ", "there", " ", 
    "are", " ", "no", " ", "graphs", " ", 
    RowBox[{"left", "."}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"k", "=", "6"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"noKCircuit", "=", 
     RowBox[{"Select", "[", 
      RowBox[{"noK5", ",", 
       RowBox[{"Function", "[", 
        RowBox[{"G", ",", 
         RowBox[{"AllTrue", "[", 
          RowBox[{
           RowBox[{"Subsets", "[", 
            RowBox[{
             RowBox[{"VertexList", "[", "G", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"k", ",", "k"}], "}"}]}], "]"}], ",", 
           RowBox[{"Function", "[", 
            RowBox[{"S", ",", 
             RowBox[{
              RowBox[{
               RowBox[{"3", "*", "k"}], "-", "6"}], ">=", 
              RowBox[{"Length", "[", 
               RowBox[{"EdgeList", "[", 
                RowBox[{"Subgraph", "[", 
                 RowBox[{"G", ",", "S"}], "]"}], "]"}], "]"}]}]}], "]"}]}], 
          "]"}]}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Length", "[", "noKCircuit", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.842459269696638*^9, 3.842459443075933*^9}, {
  3.842459481827422*^9, 3.842459614979065*^9}, {3.842460190959285*^9, 
  3.84246019355614*^9}, {3.843136588285124*^9, 3.843136589504571*^9}, {
  3.843136624812374*^9, 3.84313662775459*^9}, {3.8431379230462637`*^9, 
  3.843137973531526*^9}},ExpressionUUID->"3463a446-721e-4f03-bf6b-\
52c0d5d40270"]
},
WindowSize->{1440, 761},
WindowMargins->{{2, Automatic}, {Automatic, -1028}},
Magnification:>1.5 Inherited,
FrontEndVersion->"12.3 for Mac OS X x86 (64-bit) (July 9, 2021)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"223f35dc-93e5-4bf9-90df-0b02dfc64e44"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1097, 27, 140, "Input",ExpressionUUID->"763b639d-c652-4231-b73d-9c8e50f5a1ec"],
Cell[1658, 49, 6630, 183, 636, "Input",ExpressionUUID->"ec7ce279-899c-43ae-a553-ece32a419494"],
Cell[8291, 234, 1498, 32, 171, "Input",ExpressionUUID->"9201a35d-75ff-400e-8b47-672670292b03"],
Cell[9792, 268, 1496, 32, 140, "Input",ExpressionUUID->"ce6ce60d-5455-4de1-871b-b60ca3697b0d"],
Cell[11291, 302, 1710, 42, 233, "Input",ExpressionUUID->"75e9e0c3-e080-47a7-9851-42dc42bb794f"],
Cell[13004, 346, 1839, 43, 264, "Input",ExpressionUUID->"3463a446-721e-4f03-bf6b-52c0d5d40270"]
}
]
*)

