(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     16394,        417]
NotebookOptionsPosition[     15535,        397]
NotebookOutlinePosition[     15959,        414]
CellTagsIndexPosition[     15916,        411]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
   "pathName", "=", "\"\</Example/Path/To/Folder/With/Graph/Files/\>\""}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "Input", " ", "the", " ", "path", " ", "to", " ", "the", " ", "folder", 
     " ", "containing", " ", "the", " ", "files", " ", "with", " ", "the", 
     " ", "lists", " ", "of", " ", "graphs"}], ",", " ", 
    RowBox[{"including", " ", "a", " ", "trailing", " ", "slash"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"fileName", "=", 
  RowBox[{"StringJoin", "[", 
   RowBox[{"pathName", ",", "\"\<tenVertices.g6\>\""}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.8431370503444557`*^9, 3.843137094768383*^9}, {
   3.843137150903265*^9, 3.8431372437067432`*^9}, {3.843214991352343*^9, 
   3.84321499478988*^9}, {3.8432150322076807`*^9, 3.843215044248056*^9}, {
   3.843215141781169*^9, 3.843215142113104*^9}, 
   3.843216163038191*^9},ExpressionUUID->"47d94a1b-1755-43c2-be79-\
32bde85eebe6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Set", " ", "the", " ", "random", " ", "seed"}], ",", " ", 
    RowBox[{
    "then", " ", "define", " ", "methods", " ", "we", " ", "will", " ", "use",
      " ", "later"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"SeedRandom", "[", "1234", "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vars", "[", 
     RowBox[{"d_", ",", "n_"}], "]"}], ":=", 
    RowBox[{"Flatten", "[", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{"Function", "[", 
        RowBox[{"i", ",", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{"Function", "[", 
            RowBox[{"k", ",", 
             RowBox[{"Subscript", "[", 
              RowBox[{
               RowBox[{"Subscript", "[", 
                RowBox[{"x", ",", "i"}], "]"}], ",", "k"}], "]"}]}], "]"}], 
           ",", 
           RowBox[{"Range", "[", "d", "]"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"Range", "[", "n", "]"}]}], "]"}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"pairwiseDistances", "[", 
     RowBox[{"d_", ",", "G_"}], "]"}], ":=", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{"Function", "[", 
       RowBox[{"e", ",", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"i", ",", "j"}], "}"}], ",", 
          RowBox[{
           RowBox[{"i", "=", 
            RowBox[{"e", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ";", 
           RowBox[{"j", "=", 
            RowBox[{"e", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ";", 
           RowBox[{"Total", "[", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{"Function", "[", 
               RowBox[{"k", ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Subscript", "[", 
                    RowBox[{
                    RowBox[{"Subscript", "[", 
                    RowBox[{"x", ",", "i"}], "]"}], ",", "k"}], "]"}], "-", 
                   RowBox[{"Subscript", "[", 
                    RowBox[{
                    RowBox[{"Subscript", "[", 
                    RowBox[{"x", ",", "j"}], "]"}], ",", "k"}], "]"}]}], 
                  ")"}], "^", "2"}]}], "]"}], ",", 
              RowBox[{"Range", "[", "d", "]"}]}], "]"}], "]"}]}]}], "]"}]}], 
       "]"}], ",", "G"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"jacobian", "[", 
     RowBox[{"d_", ",", "n_", ",", "G_"}], "]"}], ":=", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{"Function", "[", 
       RowBox[{"y", ",", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"dist", ",", 
            RowBox[{"D", "[", 
             RowBox[{"dist", ",", "y"}], "]"}]}], "]"}], ",", 
          RowBox[{"pairwiseDistances", "[", 
           RowBox[{"d", ",", "G"}], "]"}]}], "]"}]}], "]"}], ",", 
      RowBox[{"vars", "[", 
       RowBox[{"d", ",", "n"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"numericalJacobian", "[", 
     RowBox[{"d_", ",", "n_", ",", "G_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"jacob", ",", "subRules"}], "}"}], ",", "\[IndentingNewLine]", 
      
      RowBox[{
       RowBox[{"jacob", "=", 
        RowBox[{"jacobian", "[", 
         RowBox[{"d", ",", "n", ",", "G"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"subRules", "=", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"y", ",", 
            RowBox[{"y", "\[Rule]", 
             RowBox[{"RandomReal", "[", "]"}]}]}], "]"}], ",", 
          RowBox[{"vars", "[", 
           RowBox[{"d", ",", "n"}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"jacob", "/.", "subRules"}]}]}], "\[IndentingNewLine]", 
     "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"edgeToIndex", "[", 
     RowBox[{"e_", ",", "n_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"FirstPosition", "[", 
      RowBox[{
       RowBox[{"K", "[", "n", "]"}], ",", "e"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"graphToIndex", "[", 
     RowBox[{"G_", ",", "n_"}], "]"}], ":=", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"edgeToIndex", "[", 
        RowBox[{"#", ",", "n"}], "]"}], "&"}], ",", "G"}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"edgeToIndex", "[", "e_", "]"}], ":=", 
    RowBox[{
     RowBox[{"FirstPosition", "[", 
      RowBox[{"K10", ",", "e"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"graphToIndex", "[", "G_", "]"}], ":=", 
    RowBox[{"Map", "[", 
     RowBox[{"edgeToIndex", ",", "G"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"actualGraphToIndex", "[", "G_", "]"}], ":=", 
    RowBox[{"graphToIndex", "[", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"#", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{"#", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "&"}], ",", 
       RowBox[{"EdgeList", "[", "G", "]"}]}], "]"}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"isIndependent", "[", "G_", "]"}], ":=", 
    RowBox[{
     RowBox[{"MatrixRank", "[", 
      RowBox[{"jacob", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "G"}], "]"}], "]"}], "]"}], "==", "25"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"K10", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"i", ",", "j"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", "9"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", 
           RowBox[{"i", "+", "1"}], ",", "10"}], "}"}]}], "]"}], ",", "1"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"jacob", "=", 
     RowBox[{"numericalJacobian", "[", 
      RowBox[{"3", ",", "10", ",", "K10"}], "]"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.8326946576183147`*^9, 3.832694709982582*^9}, {
  3.8424405755396767`*^9, 3.842440575671933*^9}, {3.84245969980192*^9, 
  3.8424597106573143`*^9}, {3.842459782325161*^9, 3.842459787300139*^9}, {
  3.842460862916369*^9, 3.842460883925351*^9}, {3.8424610270716677`*^9, 
  3.842461027336042*^9}, {3.842461089949843*^9, 3.84246109013559*^9}, {
  3.843137365243403*^9, 3.8431373765601597`*^9}, {3.8431377698431273`*^9, 
  3.843137770519308*^9}},
 CellLabel->"In[59]:=",ExpressionUUID->"ec7ce279-899c-43ae-a553-ece32a419494"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Import", " ", "and", " ", "count", " ", "the", " ", "list", " ", "of", 
    " ", "graphs", " ", "to", " ", "check"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"tenVertices", "=", 
     RowBox[{"Import", "[", "fileName", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"potentialCircuits", "=", "tenVertices"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Length", "[", "potentialCircuits", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.832679296127324*^9, 3.832679313591111*^9}, {
  3.83267943277363*^9, 3.832679466940957*^9}, {3.8424609085177383`*^9, 
  3.842460923982162*^9}, {3.842461385482461*^9, 3.842461388263404*^9}, {
  3.8424631031794033`*^9, 3.84246312224946*^9}, {3.843137100303281*^9, 
  3.84313712975135*^9}, {3.843137177286655*^9, 3.843137178316228*^9}, {
  3.8431373830208197`*^9, 3.843137391061468*^9}, {3.843214934606133*^9, 
  3.8432149348675222`*^9}},
 CellLabel->"In[72]:=",ExpressionUUID->"4ecaefe8-7315-48dc-a045-170b4efa44fe"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "Partition", " ", "based", " ", "on", " ", "whether", " ", "the", " ", 
     "graphs", " ", "appear", " ", "to", " ", "be", " ", "rigid", " ", "or", 
     " ", "flexible", " ", "according", " ", "to", " ", "a", " ", "numerical",
      " ", 
     RowBox[{"computation", ".", " ", "If"}], " ", "the", " ", "rank", " ", 
     "of", " ", "the", " ", "rigidity", " ", "matrix", " ", "is", " ", "24"}],
     ",", " ", 
    RowBox[{"then", " ", "this", " ", "certifies", " ", "rigidity"}], ",", 
    " ", 
    RowBox[{
    "but", " ", "its", " ", "possible", " ", "that", " ", "if", " ", "the", 
     " ", "rank", " ", "is", " ", "less", " ", "than", " ", "24"}], ",", " ", 
    
    RowBox[{
    "the", " ", "graph", " ", "is", " ", "still", " ", "a", " ", "rigid", " ", 
     RowBox[{"circuit", ".", " ", "We"}], " ", "eliminate", " ", "this", " ", 
     "possiblity", " ", "in", " ", "the", " ", "next", " ", 
     RowBox[{"cell", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"rigidVsFlexible", "=", 
    RowBox[{"GatherBy", "[", 
     RowBox[{"potentialCircuits", ",", 
      RowBox[{
       RowBox[{"24", "==", 
        RowBox[{"MatrixRank", "[", 
         RowBox[{"jacob", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"actualGraphToIndex", "[", "#", "]"}]}], "]"}], "]"}], 
         "]"}]}], "&"}]}], "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.842970435279867*^9, 3.842970439917704*^9}, {
  3.84297047310841*^9, 3.8429705107328167`*^9}, {3.843137392676371*^9, 
  3.843137418971202*^9}, {3.8431375141888742`*^9, 3.843137608837533*^9}},
 CellLabel->"In[75]:=",ExpressionUUID->"42e1632b-a021-4db6-9c79-3e52f61b4294"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "Verify", " ", "that", " ", "the", " ", "numerical", " ", "computation", 
     " ", "did", " ", "not", " ", "falsely", " ", "identify", " ", "any", " ",
      "rigid", " ", "circuits", " ", "as", " ", 
     RowBox[{"flexible", ".", " ", "We"}], " ", "first", " ", "eliminate", 
     " ", "the", " ", "flexible", " ", 
     RowBox[{"(", 
      RowBox[{"as", " ", "computed", " ", "numerically"}], ")"}], " ", 
     "graphs", " ", "that", " ", "had", " ", "a", " ", "K5", " ", "and", " ", 
     "are", " ", "therefore", " ", "not", " ", 
     RowBox[{"circuits", ".", " ", "Then"}]}], ",", " ", 
    RowBox[{
     RowBox[{
     "we", " ", "show", " ", "that", " ", "the", " ", "remaining", " ", 
      "graphs", " ", "are", " ", "not", " ", "3"}], "-", 
     RowBox[{
     "connected", " ", "and", " ", "therefore", " ", "not", " ", 
      "rigid"}]}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"flexible", "=", 
     RowBox[{"rigidVsFlexible", "[", 
      RowBox[{"[", "2", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"hasK5", "[", "G_", "]"}], ":=", 
    RowBox[{"AnyTrue", "[", 
     RowBox[{
      RowBox[{"Subsets", "[", 
       RowBox[{
        RowBox[{"VertexList", "[", "G", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"5", ",", "5"}], "}"}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"IsomorphicGraphQ", "[", 
        RowBox[{
         RowBox[{"CompleteGraph", "[", "5", "]"}], ",", 
         RowBox[{"Subgraph", "[", 
          RowBox[{"G", ",", "#"}], "]"}]}], "]"}], "&"}]}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"noK5", "=", 
     RowBox[{"Select", "[", 
      RowBox[{"flexible", ",", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"hasK5", "[", "#", "]"}], "]"}], "&"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Length", "[", "noK5", "]"}], "\[IndentingNewLine]", 
   RowBox[{"DeleteDuplicates", "[", 
    RowBox[{"Map", "[", 
     RowBox[{"VertexConnectivity", ",", "noK5"}], "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.842970574093013*^9, 3.8429707056117*^9}, {
  3.8429707458799553`*^9, 3.842970754777876*^9}, {3.8430488180918713`*^9, 
  3.843048823946641*^9}, {3.843137421312302*^9, 3.843137501751995*^9}, {
  3.843137614685746*^9, 3.843137666935231*^9}},
 CellLabel->"In[76]:=",ExpressionUUID->"c4897ddb-92ac-4d82-b2ce-75627d7bef90"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Show", " ", "that", " ", "exactly", " ", "one", " ", "of", " ", "the", 
    " ", "graphs", " ", "we", " ", "tested", " ", "has", " ", "a", " ", 
    "balanced", " ", 
    RowBox[{"stress", ".", " ", "This"}], " ", "graph", " ", "is", " ", 
    RowBox[{"K55", "."}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"rigidGraphs", "=", 
     RowBox[{"rigidVsFlexible", "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"zeroDiagonalStress", "=", 
     RowBox[{"Select", "[", 
      RowBox[{"rigidGraphs", ",", 
       RowBox[{"Function", "[", 
        RowBox[{"cir", ",", 
         RowBox[{
          RowBox[{"Chop", "[", 
           RowBox[{"Total", "[", 
            RowBox[{"Flatten", "[", 
             RowBox[{"NullSpace", "[", 
              RowBox[{"jacob", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", 
                 RowBox[{"actualGraphToIndex", "[", "cir", "]"}]}], "]"}], 
               "]"}], "]"}], "]"}], "]"}], "]"}], "\[Equal]", "0"}]}], 
        "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Length", "[", "zeroDiagonalStress", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.832680300966052*^9, 3.832680536625085*^9}, {
  3.832680574882139*^9, 3.832680579518403*^9}, {3.842461227868177*^9, 
  3.8424612291412687`*^9}, {3.842461286600814*^9, 3.842461306709746*^9}, {
  3.84246306920366*^9, 3.842463070866932*^9}, {3.8424631062592297`*^9, 
  3.842463111039672*^9}, {3.8424633536562557`*^9, 3.842463368353442*^9}, {
  3.842463409418518*^9, 3.842463423203416*^9}, {3.842463529150799*^9, 
  3.842463592150031*^9}, {3.843137506268394*^9, 3.843137509038872*^9}, {
  3.843137675559396*^9, 3.843137739909976*^9}, {3.843215251736216*^9, 
  3.843215262574358*^9}},
 CellLabel->"In[81]:=",ExpressionUUID->"f2b89b98-3090-4282-ac66-f32d25c3d0e7"]
},
WindowSize->{1440, 761},
WindowMargins->{{5, Automatic}, {Automatic, -956}},
Magnification:>1.5 Inherited,
FrontEndVersion->"12.3 for Mac OS X x86 (64-bit) (July 9, 2021)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"223f35dc-93e5-4bf9-90df-0b02dfc64e44"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1001, 22, 109, "Input",ExpressionUUID->"47d94a1b-1755-43c2-be79-32bde85eebe6"],
Cell[1562, 44, 6797, 184, 636, "Input",ExpressionUUID->"ec7ce279-899c-43ae-a553-ece32a419494"],
Cell[8362, 230, 1048, 21, 140, "Input",ExpressionUUID->"4ecaefe8-7315-48dc-a045-170b4efa44fe"],
Cell[9413, 253, 1746, 38, 171, "Input",ExpressionUUID->"42e1632b-a021-4db6-9c79-3e52f61b4294"],
Cell[11162, 293, 2449, 59, 295, "Input",ExpressionUUID->"c4897ddb-92ac-4d82-b2ce-75627d7bef90"],
Cell[13614, 354, 1917, 41, 171, "Input",ExpressionUUID->"f2b89b98-3090-4282-ac66-f32d25c3d0e7"]
}
]
*)

